
/**************************************************************
 *	Copyright (c) 1997 Scott M Harrison.  All rights reserved.
 *
 *	This software is provided "as is" without express or
 *	implied warranty.
 *
 *************************************************************/

/**************************************************************
 *
 *	$Source: /private/Net/mithril/HardDrive1/Users/sharris/Postgres95Adaptor/RCS/Postgres95AdaptorChannel.h,v $
 *	$Revision: 1.3 $
 *	$Date: 97/03/24 19:35:17 $
 *	$Author: sharris $
 *
 *************************************************************/

#ifdef	EOF_1_1
#import <foundation/NSDate.h>		// needed because EOAdaptorChannel.h seems to need this!!!!
#import <eoaccess/EOAdaptorChannel.h>
#endif	/* EOF_1_1 */

#ifdef	EOF_1_2
#import <EOAccess1x/EOAdaptorChannel.h>
#endif	/* EOF_1_2 */

#import <stdio.h>
#import "libpq-fe.h"

@class Postgres95Adaptor, Postgres95AdaptorContext, NSArray, NSDictionary;

@interface Postgres95AdaptorChannel : EOAdaptorChannel

	{
	PGconn *theConnection;
	PGresult *theResult;
	int currentRow;
	int maxRows;
	Postgres95Adaptor *adaptor;
	Postgres95AdaptorContext *context;   
	BOOL fetchOIDModify;
	}

- (BOOL) _connectWithConnectionDictionary: (NSDictionary *) aDictionary;
- (BOOL) fetchOIDModify;
- (void) setFetchOIDModify: (BOOL) yn;
- (EOAdaptorContext *) adaptorContext;
- (void) cancelFetch;
- (void) closeChannel;
- (void) dealloc;
- (NSArray *) describeAttributesForEntity: (EOEntity *) anEntity;
- (NSArray *) describeEntities;
- (EOModel *) describeModelWithTableNames: (NSArray *) tableNames;
- (NSArray *) describeRelationshipsForEntity: (EOEntity *) entity;
- (NSArray *) describeTableNames;
- (BOOL) evaluateExpression: (NSString *) expression;
- initWithAdaptor: (Postgres95Adaptor *) anAdaptor andContext: (Postgres95AdaptorContext *) anAdaptorContext;
- (BOOL) insertRow: (NSDictionary *) row forEntity: (EOEntity *) entity;
- (BOOL) isFetchInProgress;
- (BOOL) isOpen;
- (BOOL) openChannel;
- (BOOL) updateRow: (NSDictionary *) row describedByQualifier: (EOQualifier *) qualifier;
- (BOOL) deleteRowsDescribedByQualifier: (EOQualifier *) qualifier;
- (BOOL) selectAttributes: (NSArray *) attributes describedByQualifier: (EOQualifier *) qualifier fetchOrder: (NSArray *) fetchOrder lock: (BOOL) flag;
- (NSArray *) describeResults;
- (NSMutableDictionary *) fetchAttributes: (NSArray *) attributes withZone: (NSZone *) zone;

@end
